<?php
//
//  php-syntax-check (c) Alan Dix 2005
//
//  www.meandeviation.com
//
//  You are free to use and alter this scriopt for personal purposes.
//  If you distruibute this script or a modified version of it please include an appropriate
//  acknowledgement including the meandeviation URL.  
//
//  Note this script requires:
//
//     (1) command line installation of PHP
//         some PHP installations only include an APACHE or other moduel out of the box.
//         If this is the case you will need to hand compile the PHP (see www.php.net or documetnation)
//         or find a precompiled installation for command line use.
//         The path for PHP in $cmd will need to be altered for your system.
//         Also I assume the "-l" command line parameter which means "please syntax check only"
//         does not change between versions of PHP ... but best to check.
//         For Windows installations you will need to use the DOS equivalent "\l" perhaps???
//
//     (2) dos2unix and mac2unix converters
//         These are used to put everything into unix line format so that PHP reports syntax
//         errors on the correct lines!
//         These are standard in Linux distriobutions I believe.
//         On my system these are part of the standrd path, but if you have to isntall them
//         somewhere yourself then you will need explicit paths in $convert
//         If you install this on a Windows system you will have to do this conversion differently,
//         perhaps just read the text into a big PHP string and do translations in PHP, or use
//         equivalent DOS commands.
//         
//

include "config.php";

$upload_name = $_FILES['phpfile']['tmp_name'];
$name = $_FILES['phpfile']['name'];
$hname = htmlentities($name);

if ( !$upload_name ) {
	echo "no file uploaded :-(";
	echo "<br/>";
	echo "please press back and try again";
	exit(1);
}

$is_uploaded = is_uploaded_file($upload_name);

if ( !$is_uploaded ) {
	echo "Sorry! bad URL :-(";
	exit(1);
}


$tmp_name = tempnam( TMPDIR, "SYNCHK");

// first convert to platform native line endings
// this could be done in pure PHP, but I'm using external programs as they are available on my system

$convert = DOS2UNIX . " < $upload_name | " . MAC2UNIX . " > $tmp_name";

exec($convert,$cvout,$cvres);  

// now run command line PHP in syntax check only mode (the '-l' flag)

if ( defined('LOG_FILE_DEBUG') ) {
	$tee = " | tee " . LOG_FILE_DEBUG;
} else {
	$tee = "";
}

$cmd = "( " . PHP_CMD . " -l -d display_errors=on -d log_errors=off -f $tmp_name 2>&1 $tee )";
//$cmd = "( " . PHP_CMD . " -l -d display_errors=on -f $tmp_name 2>&1; set > /home/ajdixmd/mylogs/chk.log )";
//$cmd = "( (  " . PHP_CMD . " -C -l -f $tmp_name ) 2>/home/ajdixmd/mylogs/chk.log )";
//   SEE: http://uk.php.net/manual/en/ref.errorfunc.php#ini.display-errors

exec($cmd,$output,$result);
$len = count($output);
if ( $len <= 0 ) {
	echo "Sorry! internal error, no syntax check output :-(";
	exit(1);
}

// finally parse output of syntax check

if ( substr($output[0],0,strlen(OK_LINE_START)) == OK_LINE_START ) {
	$syntax_OK = true;
	$title = "PHP syntax check: $hname is OK :-)";
} else {
	$syntax_OK = false;
	$title = "PHP syntax check: $hname FAILED :-(";
	$filtered_output = array();
	$err_line_nos = array();
	if ( $len > 0 && rtrim($output[0]) == "<br />" )  {
		array_shift($output);
		$len--;
	}
	if ( $len > 0 && rtrim($output[$len-1]) == "Errors parsing " . $tmp_name )  {
		$len--;   // N.B. skip last line
	}
	for ( $i=0; $i < $len; $i++ ) {
		$line = $output[$i];
		$filtered_output[] = str_replace($tmp_name,$hname,$line);
		if ( preg_match(ON_LINE_PATTERN, $line, $matches) ) {
			$err_line_nos[] = $matches[ON_LINE_PATTERN_INDEX];
			echo "<!-- line " . $matches[ON_LINE_PATTERN_INDEX] . ": " . htmlentities($line) . " -->\n";
		} else {
			echo "<!-- error: " . htmlentities($line) . " -->\n";
		}
	}
	sort($err_line_nos);
	$err_line_ct = count($err_line_nos);
}

//$contentStr = file_get_contents($tmp_name);
//$highlighted = highlight_string($contentStr,true);

$highlighted = highlight_file($tmp_name,true);

$h_lines = highlight_lines($highlighted);
if ( $h_lines !== false ) {
    $contents = $h_lines;
	echo "<!-- using highlighting :-) -->";
} else {
	$contents = file($tmp_name);
	$contents =  array_map('rtrim',$contents);
	$contents =  array_map('htmlentities',$contents);
	echo "<!-- no highlighting :-( -->";
}

unlink($tmp_name);

//chmod($tmp_name,0644);

// log access in case of nasty attacks or bug reports
// remember to delete before it gets too big!

$time = date("Y-m-d H:i:s");

$clientip = getClientIp();

if ( defined(LOG_FILE) ) {
	$logline = $time . "\t" . $clientip . "\t" . $name . "\t" . $contents[0];
	
	$fp = fopen(LOG_FILE,"a");
	fwrite($fp,$logline);
	fclose($fp);
}
if ( $syntax_OK ) {
	include "html/syntax-ok.php";
} else {
	include "html/syntax-bad.php";
}

?>