<?php

function showAlternates($this_version,$class='') {
	global $alternativeVersions;
	$count = 0;
	$html = "";
	foreach ( $alternativeVersions as $vers => $versInfo ) {
		if ( $vers == $this_version ) continue;
		$url = $versInfo['url'];
		$count++;
		if ( $html ) $html .= ", ";
		$html .= '<a href="'.$url.'">PHP '.$vers.'</a>';
	}
	if ( $count == 0 ) {
		return "";
	} elseif ( $count == 1 ) {
		return '<p class="'.$class.'">An alternative version is available for ' . $html . '.</p>';
	} else  {
		return '<p class="'.$class.'">Alternative versions are available for ' . $html . '.</p>';
	}
}

function my_php_major_version_number($level=0) {
	$full = phpversion();
	$parts = explode(".",$full);
	if ( count($parts) == 0 ) return "unknown";
	$version = $parts[0];
	for ( $i=1; $i<=$level; $i++ ) {
		$version .= "." . $parts[$i];
	}
	return $version;
}

function highlight_lines($highlighted) {
	//echo "<!-- highlight_lines(\"" . substr($highlighted,0,50) . "...\") -->\n";
	//echo "<!-- highlight_lines(\"" . $highlighted . "...\") -->\n";
	
	$match = array();
	
	if ( ! preg_match( '/^(\s*' . HIGHLIGHT_START_PAT . '\s*)/' , $highlighted, $match )  ) {
			echo "<!-- bad start -->\n";
		return false;
	}
	$start_len = strlen($match[1]);
	$highlighted = substr($highlighted,$start_len);

	if ( ! preg_match( '/(\s*' . HIGHLIGHT_END_PAT . '\s*)$/' , $highlighted, $match )  ) {
			echo "<!-- bad end -->\n";
		return false;
	}
	$end_len = strlen($match[1]);
	$highlighted = substr($highlighted,0,-$end_len);
	
	$q_br = preg_quote('<br />','/');
	$q_span = preg_quote('</span>','/');
	$q_font = preg_quote('</font>','/');
	
	do {
		$old = $highlighted;
		//$highlighted =  str_replace('<br /></span>','</span><br />',$highlighted);
		$highlighted =  preg_replace('/'.$q_br.'\s*'.$q_span.'/','</span><br />',$highlighted);
	} while ( $old != $highlighted );
	do {
		$old = $highlighted;
		//$highlighted =  str_replace('<br /></font>','</font><br />',$highlighted);
		$highlighted =  preg_replace('/'.$q_br.'\s*'.$q_font.'/','</font><br />',$highlighted);
	} while ( $old != $highlighted );
	
	// code below better for PHP 5
	// $count = 0;
	//do { $highlighted = preg_replace('/'.$q_br.$q_span.'/','</span><br />',$highlighted,-1,$count); } while ( $count > 0 );
	//do { $highlighted = preg_replace('/'.$q_br.$q_font.'/','</font><br />',$highlighted,-1,$count); } while ( $count > 0 );
	
	$highlighted = trim($highlighted);
	
	$h_lines = explode('<br />',$highlighted);
	return $h_lines;
	
}

function getClientIp()
{ 
    $clientip = getenv('HTTP_X_FORWARDED_FOR');
	if ( $clientip ) return $clientip;
    $clientip = getenv('HTTP_CLIENT_IP');
	if ( $clientip ) return $clientip;
    $clientip = getenv('HTTP_FROM');
	if ( $clientip ) return $clientip;
    $clientip = getenv('REMOTE_ADDR');
	if ( $clientip ) return $clientip;
    return "";
}

function error_list() {
	global $filtered_output;
	$i=0;
	foreach ( $filtered_output as $line ) {
		$i++;
		echo $line ."\n";
	}
}

function source_list() {
	global $contents, $err_line_nos;
	$i=0;
	foreach ( $contents as $line ) {
		$i++;
		$line_nos = str_pad($i,3," ",STR_PAD_LEFT);
		//$numbered_line = $line_nos . ": " . htmlentities(rtrim($line));
		$numbered_line = $line_nos . ": " . $line;
		if ( in_array($i,$err_line_nos) ) {
			//echo  ERR_PREFIX . "<font color=\"" . HIGHLIGHT_COLOR . "\">" . $numbered_line ."</font>\n";
			//echo  '<span class="errorline">' . ERR_PREFIX . $numbered_line ."</span>\n";
			echo  ERR_PREFIX . $numbered_line ."\n";
			
		} else  {
			echo  OK_PREFIX . $numbered_line ."\n";
		}
	}
}


?>