<?php
include "config.php";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Syntax Check PHP <?php echo $version; ?> File</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="keywords" content="PHP syntax check, syntax errors in PHP">
<meta name="description" content="Introductory tutorial of basic PHP for web scripting.">

<link rel="stylesheet" href="<?php echo STYLE_SHEET; ?>" type="text/css">
</head>

<body bgcolor="#FFFFFF" text="#000000">
<font size="-1" face="Arial,Helvetica"><?php echo BREADCRUMBS; ?></font>
<h1>Syntax Check PHP <?php echo $version; ?> File</h1>
<!-- The data encoding type, enctype, MUST be specified as below -->
<p>Many PHP systems are configured not to show syntax errors (or other errors) on production web servers. If you are running a separate development server or running a server on your own PC you can set the <a href="http://www.php.net/manual/en/ref.errorfunc.php#ini.display-errors" target="_new">display_errors</a> flag to true in php.ini. This will also make it easier to check other kinds of errors. </p>
<p>However, if you cannot do this for some reason, or you just want a quick check of the PHP syntax, then this page is for you!</p>
<p>Simply select the PHP file you would like below and then press 'Check this File'. This will do a syntax check and show you  any (usually the first!) syntax errors in your file. As syntax errors are reported with line numbers and not all editors support line numbering, the results page will also show you a numbered listing of your script. </p>
<form enctype="multipart/form-data" action="do-syntax-check.php" method="POST">
    <!-- MAX_FILE_SIZE must precede the file input field -->
    <blockquote>
      <table>
	  <?php if ( MAXSIZE ): ?>
      <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo MAXSIZE; ?>" />
	  <?php endif; ?>
      <!-- Name of input element determines name in $_FILES array -->
      <tr><td class="bold"> 1. Select file to check:</td>
          <td><input name="phpfile" type="file" />
      </td></tr>
      <tr>
        <td class="bold"> 2. Check syntax:</td>    
          <td><input type="submit" value="Check this File" />
      </td></tr>
	  </table>
    </blockquote>
</form>
<p>You can download this script (tarball): <a href="<?php echo DOWNLOAD_BASE; ?>php-syntax-check.tar.gz">php-syntax-check.tar.gz</a><br>
  It will need some configuring for your system. </p>
<p>
Note this will checked against <span class="bold">PHP <?php echo $version; ?></span>.
There are slight syntax differences between versions.
</p>
<?php
echo showAlternates($version);
?>
 <hr>
<table width="100%" cellpadding="0" cellspacing="0" border="0">
    <tr>
    <td align="left"><font size="-1"><?php echo SCRIPT_BASE; ?></font></td>
    <td align="right"><font size="-1"><a href="http://www.hcibook.com/alan/">Alan Dix</a> &copy; 2005-2010</font> </td>
    </tr>
</table>

</body>
</html>
